#include "DialogMenu.h"

Application *DialogMenu::app = 0;

DialogMenu::DialogMenu(IPartSystem *sys, const char *msg, bool show_cancel, int diag_cx, int diag_cy, int diag_w) :
    RootMenu(sys, diag_cx-diag_w/2,diag_cy-90,diag_w,180, "?!") {

    is_done = false;
    choice = DIALOGMENU_BUTTON_ID_CANCEL;
    message = msg;

    interact.set_x(interact.get_x()+(interact.get_w()-al_get_text_width(menuFont, msg)+20)/2);
	interact.set_w(al_get_text_width(menuFont, msg)+20);


	if(show_cancel) {

	    if(interact.get_w()<200) interact.set_w(200);

	    but_ok = interact.add_button(sys, interact.get_w()/2-65,135,60,35, "OK", DIALOGMENU_BUTTON_ID_OK);
	    but_cancel= interact.add_button(sys, interact.get_w()/2+5,135,90,35, "Cancel", DIALOGMENU_BUTTON_ID_CANCEL);

        interact.set_adjacent_buttons(but_ok, 0, 0, but_cancel, 0);
        interact.set_adjacent_buttons(but_cancel, 0, but_ok, 0, 0);


	} else {

	    if(interact.get_w()<180) interact.set_w(180);

	    but_ok = interact.add_button(sys, interact.get_w()/2-80,135,160,35, "OK", DIALOGMENU_BUTTON_ID_OK);
	    but_cancel = 0;
	}

	interact.set_used_but(but_ok);

}

bool DialogMenu::done() {

    return is_done;

}

DIALOGMENU_BUTTON_ID DialogMenu::get_choice() {

    return choice;

}

void DialogMenu::fun_cancel() {

    choice = DIALOGMENU_BUTTON_ID_CANCEL;
	is_done = true;

}

void DialogMenu::fun_ok() {

    choice = DIALOGMENU_BUTTON_ID_OK;
	is_done = true;

}

void DialogMenu::update(ActionManager& act, Keyboard& inp_keyboard) {

	// Spin
	int index = interact.update(act, inp_keyboard);

	switch(index) {
	    case DIALOGMENU_BUTTON_ID_CANCEL:
            fun_cancel();
	    break;
	    case DIALOGMENU_BUTTON_ID_OK:
            fun_ok();
	    break;
	}

    if(act.quit()) {
        fun_cancel();
    }


}

void DialogMenu::draw(long anim_time) {

    al_draw_filled_rectangle(interact.get_x(), interact.get_y(), interact.get_x()+interact.get_w(), interact.get_y()+interact.get_h(), al_map_rgba(255,255,255,255));
    al_draw_filled_rectangle(interact.get_x(), interact.get_y(), interact.get_x()+interact.get_w(), interact.get_y()+interact.get_h(), al_map_rgba(100,159,0,100));
    al_draw_rectangle(interact.get_x(), interact.get_y(), interact.get_x()+interact.get_w(), interact.get_y()+interact.get_h(), al_map_rgba(155,155,55,100), 0.0);
    al_draw_text(menuFont, al_map_rgb(0,0,0), interact.get_x()+10, interact.get_y()+10, 0, interact.get_title());
    //al_draw_justified_text(menuFont, al_map_rgb(0,0,0), interact.get_x()+10, interact.get_x()+interact.get_w()-10, interact.get_y()+40, 50.0f, ALLEGRO_ALIGN_CENTRE, message);
    al_draw_text(menuFont, al_map_rgb(0,0,0), interact.get_x()+interact.get_w()/2, interact.get_y()+40, ALLEGRO_ALIGN_CENTRE, message);
    //al_draw_line(interact.get_x()+10, interact.get_y()+40, interact.get_x()+10, interact.get_y()+80, al_map_rgb(255,0,0), 0.0);
    //al_draw_line(interact.get_x()+interact.get_w()-10, interact.get_y()+40, interact.get_x()+interact.get_w()-10, interact.get_y()+80, al_map_rgb(255,0,0), 0.0);
	interact.draw(anim_time);

}
