#include "OptionsGraphicsMenu.h"


//Application *OptionsGraphicsMenu::app = 0;

OptionsGraphicsMenu::OptionsGraphicsMenu(IPartSystem *sys) :
    RootMenu(sys, 0,0,432,243, "Graphics Menu") {

    // ...
    fullscreen = false;

	but_fullscreen = interact.add_button(sys, 210,20,140,35, "Fullscreen", OPTGFXMENU_BUTTON_ID_FUllSCREEN);
	but_ok = interact.add_button(sys, 210,110,140,35, "OK", OPTGFXMENU_BUTTON_ID_OK);
	but_back = interact.add_button(sys, 20,160,140,35, "Back", OPTGFXMENU_BUTTON_ID_BACK);

    //but_green->set_submitCancel(NEWGAMEMENU_BUTTON_ID_OK, NEWGAMEMENU_BUTTON_ID_BACK);
    //but_fullscreen->set_submitCancel(OPTGFXMENU_BUTTON_ID_SUBMIT, 0);

	interact.set_adjacent_buttons(but_fullscreen, but_back, 0, 0, but_ok);
	interact.set_adjacent_buttons(but_ok, but_fullscreen, but_back, 0, but_back);
	interact.set_adjacent_buttons(but_back, but_ok, 0, but_ok, 0);

	interact.set_used_but(but_ok);

}

OptionsGraphicsMenu::~OptionsGraphicsMenu() {

}

void OptionsGraphicsMenu::fun_fullscreen() {

    if(fullscreen) {
        but_fullscreen->set_label("Fullscreen");
        fullscreen = false;
    } else {
        but_fullscreen->set_label("Windowed");
        fullscreen = true;
    }

}


void OptionsGraphicsMenu::fun_ok() {

    //Change fullscreen/windowed
    app -> config -> set_fullscreen(fullscreen);
    app -> fullscreen(fullscreen);
    app -> set_menu(APP_MENU_ID_OPTIONS);

}

void OptionsGraphicsMenu::fun_back() {

	app -> set_menu(APP_MENU_ID_OPTIONS);

}

void OptionsGraphicsMenu::fun_submit() {

    fun_ok();

}


void OptionsGraphicsMenu::update(ActionManager& act, Keyboard& inp_keyboard) {

    // Spin
    int index = interact.update(act, inp_keyboard);

    switch(index) {
        case OPTGFXMENU_BUTTON_ID_FUllSCREEN:
            fun_fullscreen();
        break;
        case OPTGFXMENU_BUTTON_ID_OK:
            fun_submit();
        break;
        case OPTGFXMENU_BUTTON_ID_BACK:
            fun_back();
        break;
        case OPTGFXMENU_BUTTON_ID_SUBMIT:
            fun_submit();
        break;
    }

    if(act.quit()) {

        app -> set_menu(APP_MENU_ID_MAIN);
    }

}

void OptionsGraphicsMenu::draw(long anim_time) {

    for(int y=0; y<app->config->get_screen_h(); y+=al_get_bitmap_height(menuBG)*2) {
        for(int x=0; x<app->config->get_screen_w(); x+=al_get_bitmap_width(menuBG)*2) {
            al_draw_bitmap(menuBG, x, y, 0);
            al_draw_bitmap(menuBG, x+al_get_bitmap_width(menuBG), y, ALLEGRO_FLIP_HORIZONTAL);
            al_draw_bitmap(menuBG, x, y+al_get_bitmap_height(menuBG), ALLEGRO_FLIP_VERTICAL);
            al_draw_bitmap(menuBG, x+al_get_bitmap_width(menuBG), y+al_get_bitmap_height(menuBG), ALLEGRO_FLIP_HORIZONTAL | ALLEGRO_FLIP_VERTICAL);
        }
    }

	interact.draw(anim_time);

}
