#include "OptionsJoystickMenu.h"


//Application *OptionsJoystickMenu::app = 0;

OptionsJoystickMenu::OptionsJoystickMenu(IPartSystem *sys, ActionManager& act) :
    RootMenu(sys, 0,0,app->config->get_screen_w(),app->config->get_screen_h(), "Joystick Menu") {

    stick = 0;
    act.manage_joysticks();
    if(act.get_num_joys()>0) {
        stick = act.get_joy(0);
    } else {
        //... take action
    }

    // Standard dialog
    in_dialog = false;
    dialog_id = 0;
    dialog = 0;
    // --

    int n,a;
    bool s,p;

    stick->get_bntnum(JOY_TYPE_UP, n, a, s, p);
    btn_up       = interact.add_getjoy(sys, 180, 20,207,35, n,a,p,s, 0, "Up:", OPTJOYMENU_BUTTON_ID_UP);
    stick->get_bntnum(JOY_TYPE_LEFT, n, a, s, p);
	btn_left     = interact.add_getjoy(sys, 180, 60,207,35, n,a,p,s, 0, "Left:", OPTJOYMENU_BUTTON_ID_LEFT);
	stick->get_bntnum(JOY_TYPE_RIGHT, n, a, s, p);
	btn_right    = interact.add_getjoy(sys, 180,100,207,35, n,a,p,s, 0, "Right:", OPTJOYMENU_BUTTON_ID_RIGHT);
	stick->get_bntnum(JOY_TYPE_DOWN, n, a, s, p);
	btn_down     = interact.add_getjoy(sys, 180,140,207,35, n,a,p,s, 0, "Down:", OPTJOYMENU_BUTTON_ID_DOWN);
	stick->get_bntnum(JOY_TYPE_ACT1, n, a, s, p);
	btn_act1     = interact.add_getjoy(sys, 180,180,207,35, n,a,p,s, 0, "Action 1:", OPTJOYMENU_BUTTON_ID_ACT1);
	stick->get_bntnum(JOY_TYPE_ACT2, n, a, s, p);
	btn_act2     = interact.add_getjoy(sys, 180,220,207,35, n,a,p,s, 0, "Action 2:", OPTJOYMENU_BUTTON_ID_ACT2);
	stick->get_bntnum(JOY_TYPE_ACT3, n, a, s, p);
	btn_act3     = interact.add_getjoy(sys, 180,260,207,35, n,a,p,s, 0, "Action 3:", OPTJOYMENU_BUTTON_ID_ACT3);
	stick->get_bntnum(JOY_TYPE_ACT4, n, a, s, p);
	btn_act4     = interact.add_getjoy(sys, 180,300,207,35, n,a,p,s, 0, "Action 4:", OPTJOYMENU_BUTTON_ID_ACT4);
	stick->get_bntnum(JOY_TYPE_LTRIGGER, n, a, s, p);
	btn_ltrigger = interact.add_getjoy(sys, 180,340,207,35, n,a,p,s, 0, "Left Trigger:", OPTJOYMENU_BUTTON_ID_LTRIGGER);
	stick->get_bntnum(JOY_TYPE_RTRIGGER, n, a, s, p);
	btn_rtrigger = interact.add_getjoy(sys, 180,380,207,35, n,a,p,s, 0, "Right Trigger:", OPTJOYMENU_BUTTON_ID_RTRIGGER);
	stick->get_bntnum(JOY_TYPE_START, n, a, s, p);
	btn_start    = interact.add_getjoy(sys, 180,420,207,35, n,a,p,s, 0, "Start:", OPTJOYMENU_BUTTON_ID_START);
	stick->get_bntnum(JOY_TYPE_SELECT, n, a, s, p);
	btn_select   = interact.add_getjoy(sys, 180,460,207,35, n,a,p,s, 0, "Select:", OPTJOYMENU_BUTTON_ID_SELECT);

	btn_back     = interact.add_button(sys, 180,500,140,35, "Back", OPTJOYMENU_BUTTON_ID_BACK);

	interact.set_adjacent_buttons(btn_up, btn_select, btn_back, 0, btn_left);
	interact.set_adjacent_buttons(btn_left, btn_up, btn_back, 0, btn_right);
	interact.set_adjacent_buttons(btn_right, btn_left, btn_back, 0, btn_down);
	interact.set_adjacent_buttons(btn_down, btn_right, btn_back, 0, btn_act1);
	interact.set_adjacent_buttons(btn_act1, btn_down, btn_back, 0, btn_act2);
	interact.set_adjacent_buttons(btn_act2, btn_act1, btn_back, 0, btn_act3);
	interact.set_adjacent_buttons(btn_act3, btn_act2, btn_back, 0, btn_act4);
	interact.set_adjacent_buttons(btn_act4, btn_act3, btn_back, 0, btn_ltrigger);
	interact.set_adjacent_buttons(btn_ltrigger, btn_act4, btn_back, 0, btn_rtrigger);
	interact.set_adjacent_buttons(btn_rtrigger, btn_ltrigger, btn_back, 0, btn_start);
	interact.set_adjacent_buttons(btn_start, btn_rtrigger, btn_back, 0, btn_select);
	interact.set_adjacent_buttons(btn_select, btn_start, btn_back, 0, btn_up);
	interact.set_adjacent_buttons(btn_back, btn_up, 0, btn_act1, btn_select);

	interact.set_used_but(btn_act1);
    reposition();
    interact.set_used_but(btn_back);


    conflict = false;
    restore();
}

OptionsJoystickMenu::~OptionsJoystickMenu() {
    if(dialog!=0) delete dialog;
}

void OptionsJoystickMenu::restore() {

    conflict = false;
    if(btn_up->test(stick)       >= 0) conflict = true;
    if(btn_left->test(stick)     >= 0) conflict = true;
    if(btn_right->test(stick)    >= 0) conflict = true;
    if(btn_down->test(stick)     >= 0) conflict = true;
    if(btn_act1->test(stick)     >= 0) conflict = true;
    if(btn_act2->test(stick)     >= 0) conflict = true;
    if(btn_act3->test(stick)     >= 0) conflict = true;
    if(btn_act4->test(stick)     >= 0) conflict = true;
    if(btn_ltrigger->test(stick) >= 0) conflict = true;
    if(btn_rtrigger->test(stick) >= 0) conflict = true;
    if(btn_start->test(stick)    >= 0) conflict = true;
    if(btn_select->test(stick)   >= 0) conflict = true;

}

void OptionsJoystickMenu::reposition() {

    interact.set_y(-interact.get_used_but()->get_y() + (interact.get_h()-interact.get_used_but()->get_h())/2.0);
    //if(interact.get_y()>-80) interact.set_y(80);
    //if(interact.get_y()<-max_y()+interact.get_h()+80) interact.set_y(max_y()-interact.get_h()-80);
    btn_back->set_x(interact.get_x()+20);
    btn_back->set_y(-interact.get_y()+(interact.get_h()-btn_back->get_h())/2.0);

}



int OptionsJoystickMenu::max_y() {

    int ret = 0;

    if(btn_up->get_y()+btn_up->get_h()>ret) ret=btn_up->get_y()+btn_up->get_h();
	if(btn_left->get_y()+btn_left->get_h()>ret) ret=btn_left->get_y()+btn_left->get_h();
	if(btn_right->get_y()+btn_right->get_h()>ret) ret=btn_right->get_y()+btn_right->get_h();
	if(btn_down->get_y()+btn_down->get_h()>ret) ret=btn_down->get_y()+btn_down->get_h();
	if(btn_act1->get_y()+btn_act1->get_h()>ret) ret=btn_act1->get_y()+btn_act1->get_h();
	if(btn_act2->get_y()+btn_act2->get_h()>ret) ret=btn_act2->get_y()+btn_act2->get_h();
	if(btn_act3->get_y()+btn_act3->get_h()>ret) ret=btn_act3->get_y()+btn_act3->get_h();
	if(btn_act4->get_y()+btn_act4->get_h()>ret) ret=btn_act4->get_y()+btn_act4->get_h();
	if(btn_ltrigger->get_y()+btn_ltrigger->get_h()>ret) ret=btn_ltrigger->get_y()+btn_ltrigger->get_h();
	if(btn_rtrigger->get_y()+btn_rtrigger->get_h()>ret) ret=btn_rtrigger->get_y()+btn_rtrigger->get_h();
	if(btn_start->get_y()+btn_start->get_h()>ret) ret=btn_start->get_y()+btn_start->get_h();
	if(btn_select->get_y()+btn_select->get_h()>ret) ret=btn_select->get_y()+btn_select->get_h();

	return ret;


}

void OptionsJoystickMenu::fun_up() {

    int n,a; bool s,p; int j;
    btn_up->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_UP, n);
    else stick->set_axis(JOY_TYPE_UP, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_left() {
    int n,a; bool s,p; int j;
    btn_left->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_LEFT, n);
    else stick->set_axis(JOY_TYPE_LEFT, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_right() {
    int n,a; bool s,p; int j;
    btn_right->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_RIGHT, n);
    else stick->set_axis(JOY_TYPE_RIGHT, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_down() {
    int n,a; bool s,p; int j;
    btn_down->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_DOWN, n);
    else stick->set_axis(JOY_TYPE_DOWN, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_act1() {
    int n,a; bool s,p; int j;
    btn_act1->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_ACT1, n);
    else stick->set_axis(JOY_TYPE_ACT1, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_act2() {
    int n,a; bool s,p; int j;
    btn_act2->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_ACT2, n);
    else stick->set_axis(JOY_TYPE_ACT2, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_act3() {
    int n,a; bool s,p; int j;
    btn_act3->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_ACT3, n);
    else stick->set_axis(JOY_TYPE_ACT3, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_act4() {
    int n,a; bool s,p; int j;
    btn_act4->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_ACT4, n);
    else stick->set_axis(JOY_TYPE_ACT4, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_ltrigger() {
    int n,a; bool s,p; int j;
    btn_ltrigger->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_LTRIGGER, n);
    else stick->set_axis(JOY_TYPE_LTRIGGER, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_rtrigger() {
    int n,a; bool s,p; int j;
    btn_rtrigger->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_RTRIGGER, n);
    else stick->set_axis(JOY_TYPE_RTRIGGER, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_start() {
    int n,a; bool s,p; int j;
    btn_start->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_START, n);
    else stick->set_axis(JOY_TYPE_START, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_select() {
    int n,a; bool s,p; int j;
    btn_select->get_value(n,a,p,s,j);
    if(!s) stick->set_joy(JOY_TYPE_SELECT, n);
    else stick->set_axis(JOY_TYPE_SELECT, n, a, p);
    restore();
}

void OptionsJoystickMenu::fun_back() {

    if(!conflict) {

        app->set_menu(APP_MENU_ID_MAIN);

    } else {
        dialog_id = OPTJOYMENU_DIALOG_ID_WARNREDS;
        in_dialog = true;
        dialog = new DialogMenu(partsys, "Warning: Same button used for more than one action. Use these settings?", true);
    }
}

void OptionsJoystickMenu::update(ActionManager& act, Keyboard& inp_keyboard) {

    if(in_dialog) {

        // Prompt action
        switch(dialog_id) {
            case OPTJOYMENU_DIALOG_ID_WARNREDS:
            default:
                dialog->update(act, inp_keyboard);
            break;
        }

        if(dialog->done()) {
            // Player choose yes
            switch(dialog_id) {
                case OPTJOYMENU_DIALOG_ID_WARNREDS:
                    if(dialog->get_choice()==DIALOGMENU_BUTTON_ID_OK) {
                        app->set_menu(APP_MENU_ID_MAIN);
                    }
                break;
            }
        }

        if(dialog->done()) {
            delete dialog;
            dialog = 0;
            dialog_id = 0;
            in_dialog = false;
        }

    } else {

        // Spin
        int index = interact.update(act, inp_keyboard);

        if(interact.get_used_but()!=btn_back) {
           reposition();
           interact.set_adjacent_buttons(btn_back, btn_up, 0, interact.get_used_but(), btn_select);
        }


        switch(index) {
            case OPTJOYMENU_BUTTON_ID_UP:
                fun_up();
            break;
            case OPTJOYMENU_BUTTON_ID_LEFT:
                fun_left();
            break;
            case OPTJOYMENU_BUTTON_ID_RIGHT:
                fun_right();
            break;
            case OPTJOYMENU_BUTTON_ID_DOWN:
                fun_down();
            break;
            case OPTJOYMENU_BUTTON_ID_ACT1:
                fun_act1();
            break;
            case OPTJOYMENU_BUTTON_ID_ACT2:
                fun_act2();
            break;
            case OPTJOYMENU_BUTTON_ID_ACT3:
                fun_act3();
            break;
            case OPTJOYMENU_BUTTON_ID_ACT4:
                fun_act4();
            break;
            case OPTJOYMENU_BUTTON_ID_LTRIGGER:
                fun_ltrigger();
            break;
            case OPTJOYMENU_BUTTON_ID_RTRIGGER:
                fun_rtrigger();
            break;
            case OPTJOYMENU_BUTTON_ID_START:
                fun_start();
            break;
            case OPTJOYMENU_BUTTON_ID_SELECT:
                fun_select();
            break;
            case OPTJOYMENU_BUTTON_ID_BACK:
                fun_back();
            break;
        }


        if(act.quit()) {

            app -> set_menu(APP_MENU_ID_OPTIONS);
        }
    }

}

void OptionsJoystickMenu::draw(long anim_time) {

    for(int y=0; y<app->config->get_screen_h(); y+=al_get_bitmap_height(menuBG)*2) {
        for(int x=0; x<app->config->get_screen_w(); x+=al_get_bitmap_width(menuBG)*2) {
            al_draw_bitmap(menuBG, x, y, 0);
            al_draw_bitmap(menuBG, x+al_get_bitmap_width(menuBG), y, ALLEGRO_FLIP_HORIZONTAL);
            al_draw_bitmap(menuBG, x, y+al_get_bitmap_height(menuBG), ALLEGRO_FLIP_VERTICAL);
            al_draw_bitmap(menuBG, x+al_get_bitmap_width(menuBG), y+al_get_bitmap_height(menuBG), ALLEGRO_FLIP_HORIZONTAL | ALLEGRO_FLIP_VERTICAL);
        }
    }


	interact.draw(anim_time);
/*
    if(al_get_joystick_stick_flags(stick->get_identity(),0)==ALLEGRO_JOYFLAG_ANALOGUE) al_draw_textf(menuFont, al_map_rgb(255,255,255), 10,50, 0, "JOYSTICK: %s (Analogue)", al_get_joystick_name(stick->get_identity()));
    else if(al_get_joystick_stick_flags(stick->get_identity(),0)==ALLEGRO_JOYFLAG_DIGITAL) al_draw_textf(menuFont, al_map_rgb(255,255,255), 10,50, 0, "JOYSTICK: %s (Digital)", al_get_joystick_name(stick->get_identity()));
    else al_draw_textf(menuFont, al_map_rgb(255,255,255), 10,50, 0, "JOYSTICK: %s (Not analogue, not digital)", al_get_joystick_name(stick->get_identity()));
*/

    if(in_dialog) {
        dialog->draw(anim_time);
    }

}

