#ifndef OPTIONSJOYSTICKMENU_H_INCLUDED
#define OPTIONSJOYSTICKMENU_H_INCLUDED

class DialogMenu;

#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_color.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>

//#include "application.h"
#include "menu.h"
#include "application.h"
//#include "DialogMenu.h"

enum {
    OPTJOYMENU_BUTTON_ID_UP=1,
    OPTJOYMENU_BUTTON_ID_LEFT,
    OPTJOYMENU_BUTTON_ID_RIGHT,
    OPTJOYMENU_BUTTON_ID_DOWN,
    OPTJOYMENU_BUTTON_ID_ACT1,
    OPTJOYMENU_BUTTON_ID_ACT2,
    OPTJOYMENU_BUTTON_ID_ACT3,
    OPTJOYMENU_BUTTON_ID_ACT4,
    OPTJOYMENU_BUTTON_ID_LTRIGGER,
    OPTJOYMENU_BUTTON_ID_RTRIGGER,
    OPTJOYMENU_BUTTON_ID_START,
    OPTJOYMENU_BUTTON_ID_SELECT,
    OPTJOYMENU_BUTTON_ID_BACK
};

enum {
    OPTJOYMENU_DIALOG_ID_WARNREDS=1
};


class OptionsJoystickMenu : public RootMenu {

	public:

	OptionsJoystickMenu(IPartSystem *sys, ActionManager& act);
	~OptionsJoystickMenu();

	// Button functions
	void fun_up();
	void fun_left();
	void fun_right();
	void fun_down();
	void fun_act1();
	void fun_act2();
	void fun_act3();
	void fun_act4();
	void fun_ltrigger();
	void fun_rtrigger();
	void fun_start();
	void fun_select();
	void fun_back();

    void update(ActionManager& act, Keyboard& inp_keyboard);
	void draw(long anim_time);

    //static Application *app;


	private:

    Joystick *stick;

	bool conflict;
	void restore();
    void reposition();
    int max_y();

	bool in_dialog;
    int dialog_id;
    DialogMenu *dialog;

	IGetJoy *btn_up;
	IGetJoy *btn_left;
	IGetJoy *btn_right;
	IGetJoy *btn_down;
	IGetJoy *btn_act1;
	IGetJoy *btn_act2;
	IGetJoy *btn_act3;
	IGetJoy *btn_act4;
	IGetJoy *btn_ltrigger;
	IGetJoy *btn_rtrigger;
	IGetJoy *btn_start;
	IGetJoy *btn_select;
	IButton *btn_back;


};

#endif // OPTIONSJOYSTICKMENU_H_INCLUDED
