#include "OptionsKeyboardMenu.h"

//Application *OptionsKeyboardMenu::app = 0;

OptionsKeyboardMenu::OptionsKeyboardMenu(IPartSystem *sys, Keyboard& inp_keyboard) :
    RootMenu(sys, 0,0,app->config->get_screen_w(),app->config->get_screen_h(), "Keyboard Menu") {

    // Standard dialog
    in_dialog = false;
    dialog_id = 0;
    dialog = 0;
    // --

    btn_up       = interact.add_getkey(sys, 180, 20,207,35, inp_keyboard.get_keycode1(KEY_TYPE_UP), inp_keyboard.get_keycode2(KEY_TYPE_UP), "Up:", OPTKEYMENU_BUTTON_ID_UP);
	btn_left     = interact.add_getkey(sys, 180, 60,207,35, inp_keyboard.get_keycode1(KEY_TYPE_LEFT), inp_keyboard.get_keycode2(KEY_TYPE_LEFT), "Left:", OPTKEYMENU_BUTTON_ID_LEFT);
	btn_right    = interact.add_getkey(sys, 180,100,207,35, inp_keyboard.get_keycode1(KEY_TYPE_RIGHT), inp_keyboard.get_keycode2(KEY_TYPE_RIGHT), "Right:", OPTKEYMENU_BUTTON_ID_RIGHT);
	btn_down     = interact.add_getkey(sys, 180,140,207,35, inp_keyboard.get_keycode1(KEY_TYPE_DOWN), inp_keyboard.get_keycode2(KEY_TYPE_DOWN), "Down:", OPTKEYMENU_BUTTON_ID_DOWN);
	btn_act1     = interact.add_getkey(sys, 180,180,207,35, inp_keyboard.get_keycode1(KEY_TYPE_ACT1), inp_keyboard.get_keycode2(KEY_TYPE_ACT1), "Action 1:", OPTKEYMENU_BUTTON_ID_ACT1);
	btn_act2     = interact.add_getkey(sys, 180,220,207,35, inp_keyboard.get_keycode1(KEY_TYPE_ACT2), inp_keyboard.get_keycode2(KEY_TYPE_ACT2), "Action 2:", OPTKEYMENU_BUTTON_ID_ACT2);
	btn_act3     = interact.add_getkey(sys, 180,260,207,35, inp_keyboard.get_keycode1(KEY_TYPE_ACT3), inp_keyboard.get_keycode2(KEY_TYPE_ACT3), "Action 3:", OPTKEYMENU_BUTTON_ID_ACT3);
	btn_act4     = interact.add_getkey(sys, 180,300,207,35, inp_keyboard.get_keycode1(KEY_TYPE_ACT4), inp_keyboard.get_keycode2(KEY_TYPE_ACT4), "Action 4:", OPTKEYMENU_BUTTON_ID_ACT4);
	btn_ltrigger = interact.add_getkey(sys, 180,340,207,35, inp_keyboard.get_keycode1(KEY_TYPE_LTRIGGER), inp_keyboard.get_keycode2(KEY_TYPE_LTRIGGER), "Left Trigger:", OPTKEYMENU_BUTTON_ID_LTRIGGER);
	btn_rtrigger = interact.add_getkey(sys, 180,380,207,35, inp_keyboard.get_keycode1(KEY_TYPE_RTRIGGER), inp_keyboard.get_keycode2(KEY_TYPE_RTRIGGER), "Right Trigger:", OPTKEYMENU_BUTTON_ID_RTRIGGER);
	btn_start    = interact.add_getkey(sys, 180,420,207,35, inp_keyboard.get_keycode1(KEY_TYPE_START), inp_keyboard.get_keycode2(KEY_TYPE_START), "Start:", OPTKEYMENU_BUTTON_ID_START);
	btn_select   = interact.add_getkey(sys, 180,460,207,35, inp_keyboard.get_keycode1(KEY_TYPE_SELECT), inp_keyboard.get_keycode2(KEY_TYPE_SELECT), "Select:", OPTKEYMENU_BUTTON_ID_SELECT);
	btn_back     = interact.add_button(sys, 180,500,140,35, "Back", OPTKEYMENU_BUTTON_ID_BACK);

    btn_up->disable();
    btn_down->disable();
    btn_left->disable();
    btn_right->disable();

	interact.set_adjacent_buttons(btn_up, btn_select, btn_back, 0, btn_left);
	interact.set_adjacent_buttons(btn_left, btn_up, btn_back, 0, btn_right);
	interact.set_adjacent_buttons(btn_right, btn_left, btn_back, 0, btn_down);
	interact.set_adjacent_buttons(btn_down, btn_right, btn_back, 0, btn_act1);
	interact.set_adjacent_buttons(btn_act1, btn_down, btn_back, 0, btn_act2);
	interact.set_adjacent_buttons(btn_act2, btn_act1, btn_back, 0, btn_act3);
	interact.set_adjacent_buttons(btn_act3, btn_act2, btn_back, 0, btn_act4);
	interact.set_adjacent_buttons(btn_act4, btn_act3, btn_back, 0, btn_ltrigger);
	interact.set_adjacent_buttons(btn_ltrigger, btn_act4, btn_back, 0, btn_rtrigger);
	interact.set_adjacent_buttons(btn_rtrigger, btn_ltrigger, btn_back, 0, btn_start);
	interact.set_adjacent_buttons(btn_start, btn_rtrigger, btn_back, 0, btn_select);
	interact.set_adjacent_buttons(btn_select, btn_start, btn_back, 0, btn_up);
	interact.set_adjacent_buttons(btn_back, btn_up, 0, btn_act1, btn_select);

	interact.set_used_but(btn_act1);
    reposition();
    interact.set_used_but(btn_back);


    conflict = false;
    restore(inp_keyboard);
}

OptionsKeyboardMenu::~OptionsKeyboardMenu() {
    if(dialog!=0) delete dialog;
}

void OptionsKeyboardMenu::on_conflict(KEY_TYPE t, Keyboard& inp_keyboard) {

    switch(t) {
        case KEY_TYPE_UP: btn_up->test(inp_keyboard); break;
        case KEY_TYPE_LEFT: btn_left->test(inp_keyboard); break;
        case KEY_TYPE_RIGHT: btn_right->test(inp_keyboard); break;
        case KEY_TYPE_DOWN: btn_down->test(inp_keyboard); break;
        case KEY_TYPE_ACT1: btn_act1->test(inp_keyboard); break;
        case KEY_TYPE_ACT2: btn_act2->test(inp_keyboard); break;
        case KEY_TYPE_ACT3: btn_act3->test(inp_keyboard); break;
        case KEY_TYPE_ACT4: btn_act4->test(inp_keyboard); break;
        case KEY_TYPE_LTRIGGER: btn_ltrigger->test(inp_keyboard); break;
        case KEY_TYPE_RTRIGGER: btn_rtrigger->test(inp_keyboard); break;
        case KEY_TYPE_START: btn_start->test(inp_keyboard); break;
        case KEY_TYPE_SELECT: btn_select->test(inp_keyboard); break;
    }

}

void OptionsKeyboardMenu::restore(Keyboard& inp_keyboard) {

    conflict = false;
    if(btn_up->test(inp_keyboard)       != KEY_TYPE_QUIT) conflict = true;
    if(btn_left->test(inp_keyboard)     != KEY_TYPE_QUIT) conflict = true;
    if(btn_right->test(inp_keyboard)    != KEY_TYPE_QUIT) conflict = true;
    if(btn_down->test(inp_keyboard)     != KEY_TYPE_QUIT) conflict = true;
    if(btn_act1->test(inp_keyboard)     != KEY_TYPE_QUIT) conflict = true;
    if(btn_act2->test(inp_keyboard)     != KEY_TYPE_QUIT) conflict = true;
    if(btn_act3->test(inp_keyboard)     != KEY_TYPE_QUIT) conflict = true;
    if(btn_act4->test(inp_keyboard)     != KEY_TYPE_QUIT) conflict = true;
    if(btn_ltrigger->test(inp_keyboard) != KEY_TYPE_QUIT) conflict = true;
    if(btn_rtrigger->test(inp_keyboard) != KEY_TYPE_QUIT) conflict = true;
    if(btn_start->test(inp_keyboard)    != KEY_TYPE_QUIT) conflict = true;
    if(btn_select->test(inp_keyboard)   != KEY_TYPE_QUIT) conflict = true;

}

void OptionsKeyboardMenu::reposition() {

    interact.set_y(-interact.get_used_but()->get_y() + (interact.get_h()-interact.get_used_but()->get_h())/2.0);
    //if(interact.get_y()>-80) interact.set_y(80);
    //if(interact.get_y()<-max_y()+interact.get_h()+80) interact.set_y(max_y()-interact.get_h()-80);
    btn_back->set_x(interact.get_x()+20);
    btn_back->set_y(-interact.get_y()+(interact.get_h()-btn_back->get_h())/2.0);

}



int OptionsKeyboardMenu::max_y() {

    int ret = 0;

    if(btn_up->get_y()+btn_up->get_h()>ret) ret=btn_up->get_y()+btn_up->get_h();
	if(btn_left->get_y()+btn_left->get_h()>ret) ret=btn_left->get_y()+btn_left->get_h();
	if(btn_right->get_y()+btn_right->get_h()>ret) ret=btn_right->get_y()+btn_right->get_h();
	if(btn_down->get_y()+btn_down->get_h()>ret) ret=btn_down->get_y()+btn_down->get_h();
	if(btn_act1->get_y()+btn_act1->get_h()>ret) ret=btn_act1->get_y()+btn_act1->get_h();
	if(btn_act2->get_y()+btn_act2->get_h()>ret) ret=btn_act2->get_y()+btn_act2->get_h();
	if(btn_act3->get_y()+btn_act3->get_h()>ret) ret=btn_act3->get_y()+btn_act3->get_h();
	if(btn_act4->get_y()+btn_act4->get_h()>ret) ret=btn_act4->get_y()+btn_act4->get_h();
	if(btn_ltrigger->get_y()+btn_ltrigger->get_h()>ret) ret=btn_ltrigger->get_y()+btn_ltrigger->get_h();
	if(btn_rtrigger->get_y()+btn_rtrigger->get_h()>ret) ret=btn_rtrigger->get_y()+btn_rtrigger->get_h();
	if(btn_start->get_y()+btn_start->get_h()>ret) ret=btn_start->get_y()+btn_start->get_h();
	if(btn_select->get_y()+btn_select->get_h()>ret) ret=btn_select->get_y()+btn_select->get_h();

	return ret;


}

void OptionsKeyboardMenu::fun_up(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_UP, btn_up->get_value1(), btn_up->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_left(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_LEFT, btn_left->get_value1(), btn_left->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_right(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_ACT4, btn_right->get_value1(), btn_right->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_down(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_DOWN, btn_down->get_value1(), btn_down->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_act1(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_ACT1, btn_act1->get_value1(), btn_act1->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_act2(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_ACT2, btn_act2->get_value1(), btn_act2->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_act3(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_ACT3, btn_act3->get_value1(), btn_act3->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_act4(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_ACT4, btn_act4->get_value1(), btn_act4->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_ltrigger(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_LTRIGGER, btn_ltrigger->get_value1(), btn_ltrigger->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_rtrigger(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_RTRIGGER, btn_rtrigger->get_value1(), btn_rtrigger->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_start(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_START, btn_start->get_value1(), btn_start->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_select(Keyboard& inp_keyboard) {
    inp_keyboard.set_key(KEY_TYPE_SELECT, btn_select->get_value1(), btn_select->get_value2());
    restore(inp_keyboard);
}

void OptionsKeyboardMenu::fun_back() {

    if(!conflict) {

        app->set_menu(APP_MENU_ID_MAIN);

    } else {
        dialog_id = OPTKEYMENU_DIALOG_ID_WARNREDS;
        in_dialog = true;
        dialog = new DialogMenu(partsys, "Warning: Same key used for more than one action. Use these settings?", true);
    }

}

void OptionsKeyboardMenu::update(ActionManager& act, Keyboard& inp_keyboard) {

    if(in_dialog) {

        // Prompt action
        switch(dialog_id) {
            case OPTKEYMENU_DIALOG_ID_WARNREDS:
            default:
                dialog->update(act, inp_keyboard);
            break;
        }

        if(dialog->done()) {
            // Player choose yes
            switch(dialog_id) {
                case OPTKEYMENU_DIALOG_ID_WARNREDS:
                    if(dialog->get_choice()==DIALOGMENU_BUTTON_ID_OK) {
                        app->set_menu(APP_MENU_ID_MAIN);
                    }
                break;
            }
        }

        if(dialog->done()) {
            delete dialog;
            dialog = 0;
            dialog_id = 0;
            in_dialog = false;
        }

    } else {

        // Spin
        int index = interact.update(act, inp_keyboard);

        if(interact.get_used_but()!=btn_back) {
           reposition();
           interact.set_adjacent_buttons(btn_back, btn_up, 0, interact.get_used_but(), btn_select);
        }


        switch(index) {
            case OPTKEYMENU_BUTTON_ID_UP:
                fun_up(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_LEFT:
                fun_left(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_RIGHT:
                fun_right(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_DOWN:
                fun_down(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_ACT1:
                fun_act1(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_ACT2:
                fun_act2(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_ACT3:
                fun_act3(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_ACT4:
                fun_act4(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_LTRIGGER:
                fun_ltrigger(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_RTRIGGER:
                fun_rtrigger(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_START:
                fun_start(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_SELECT:
                fun_select(inp_keyboard);
            break;
            case OPTKEYMENU_BUTTON_ID_BACK:
                fun_back();
            break;
        }

        if(act.quit()) {

            app -> set_menu(APP_MENU_ID_OPTIONS);
        }

    }

}

void OptionsKeyboardMenu::draw(long anim_time) {

    for(int y=0; y<app->config->get_screen_h(); y+=al_get_bitmap_height(menuBG)*2) {
        for(int x=0; x<app->config->get_screen_w(); x+=al_get_bitmap_width(menuBG)*2) {
            al_draw_bitmap(menuBG, x, y, 0);
            al_draw_bitmap(menuBG, x+al_get_bitmap_width(menuBG), y, ALLEGRO_FLIP_HORIZONTAL);
            al_draw_bitmap(menuBG, x, y+al_get_bitmap_height(menuBG), ALLEGRO_FLIP_VERTICAL);
            al_draw_bitmap(menuBG, x+al_get_bitmap_width(menuBG), y+al_get_bitmap_height(menuBG), ALLEGRO_FLIP_HORIZONTAL | ALLEGRO_FLIP_VERTICAL);
        }
    }

	interact.draw(anim_time);

    if(in_dialog) {
        dialog->draw(anim_time);
    }

}

