#ifndef OPTIONSKEYBOARDMENU_H_INCLUDED
#define OPTIONSKEYBOARDMENU_H_INCLUDED

class DialogMenu;

//#include "application.h"
#include "menu.h"
#include "application.h"
//#include "DialogMenu.h"

enum {
    OPTKEYMENU_BUTTON_ID_UP=1,
    OPTKEYMENU_BUTTON_ID_LEFT,
    OPTKEYMENU_BUTTON_ID_RIGHT,
    OPTKEYMENU_BUTTON_ID_DOWN,
    OPTKEYMENU_BUTTON_ID_ACT1,
    OPTKEYMENU_BUTTON_ID_ACT2,
    OPTKEYMENU_BUTTON_ID_ACT3,
    OPTKEYMENU_BUTTON_ID_ACT4,
    OPTKEYMENU_BUTTON_ID_LTRIGGER,
    OPTKEYMENU_BUTTON_ID_RTRIGGER,
    OPTKEYMENU_BUTTON_ID_START,
    OPTKEYMENU_BUTTON_ID_SELECT,
    OPTKEYMENU_BUTTON_ID_BACK
};

enum {
    OPTKEYMENU_DIALOG_ID_WARNREDS=1
};

class OptionsKeyboardMenu : public RootMenu {

	public:

	OptionsKeyboardMenu(IPartSystem *sys, Keyboard& inp_keyboard);
	~OptionsKeyboardMenu();

	// Button functions
	void fun_up(Keyboard& inp_keyboard);
	void fun_left(Keyboard& inp_keyboard);
	void fun_right(Keyboard& inp_keyboard);
	void fun_down(Keyboard& inp_keyboard);
	void fun_act1(Keyboard& inp_keyboard);
	void fun_act2(Keyboard& inp_keyboard);
	void fun_act3(Keyboard& inp_keyboard);
	void fun_act4(Keyboard& inp_keyboard);
	void fun_ltrigger(Keyboard& inp_keyboard);
	void fun_rtrigger(Keyboard& inp_keyboard);
	void fun_start(Keyboard& inp_keyboard);
	void fun_select(Keyboard& inp_keyboard);
	void fun_back();

    void update(ActionManager& act, Keyboard& inp_keyboard);
	void draw(long anim_time);

    //static Application *app;


	private:


	bool conflict;
	void restore(Keyboard& inp_keyboard);
	void on_conflict(KEY_TYPE t, Keyboard& inp_keyboard);
    void reposition();
    int max_y();

	bool in_dialog;
    int dialog_id;
    DialogMenu *dialog;

	IGetKey *btn_up;
	IGetKey *btn_left;
	IGetKey *btn_right;
	IGetKey *btn_down;
	IGetKey *btn_act1;
	IGetKey *btn_act2;
	IGetKey *btn_act3;
	IGetKey *btn_act4;
	IGetKey *btn_ltrigger;
	IGetKey *btn_rtrigger;
	IGetKey *btn_start;
	IGetKey *btn_select;
	IButton *btn_back;


};

#endif // OPTIONSKEYBOARDMENU_H_INCLUDED
