#ifndef ACTION_H_INCLUDED
#define ACTION_H_INCLUDED

#include <vector>
#include <allegro5/allegro.h>
#include "control.h"
#include "key.h"
#include "joystick.h"

enum ACTION_TYPE {
    BUT_ANY,
	BUT_START,
	BUT_SELECT,
	BUT_A,
	BUT_B,
	BUT_C,
	BUT_D,
	BUT_LT,
	BUT_RT,
	BUT_UP,
	BUT_DOWN,
	BUT_LEFT,
	BUT_RIGHT
};

// HANDLE INPUT ON KEYBOARD AND JOYSTICK
class ActionManager {

	public:

	ActionManager();
	~ActionManager();

	void add_keyboard(Keyboard * inp_keyboard);
	void add_joystick(Joystick * inp_joystick);
	void add_known_joystick(Joystick * inp_joystick);
	void config_joystick(int JoyNum);
	void manage_joysticks();
	int get_num_joys();
	Joystick * get_joy(int n);

	// Give info for action weather keyboard or joystick is used

	bool ANY();
	bool START();
	bool SELECT();
	bool A();
	bool B();
	bool C();
	bool D();
	bool LT();
	bool RT();
	bool UP();
	bool DOWN();
	bool LEFT();
	bool RIGHT();

	bool held(ACTION_TYPE act=BUT_ANY);
	bool pressed(ACTION_TYPE act=BUT_ANY);
	bool released(ACTION_TYPE act=BUT_ANY);
	bool quit();

	private:

	Keyboard *keys;
	KEY_TYPE map_key[13];
	JOY_TYPE map_joy[13];

    int joystick_memory_len;
    std::vector<Joystick*> list_known_joysticks;
    std::vector<Joystick*> list_joystick;

};


#endif // ACTION_H_INCLUDED
