#ifndef ANIM_H_INCLUDED
#define ANIM_H_INCLUDED

#include <stdio.h>
#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include "resources.h"

class Sprite {

	public:

	Sprite(const char * filename);
	~Sprite();

	ALLEGRO_BITMAP *get();
	//void set(const char *filename);

	virtual void draw(int x, int y);
	int get_w();
	int get_h();

	protected:

    const char *path;
	ALLEGRO_BITMAP *gfx;
	int w, h;

};


class Anim : public Sprite {

	public:

	Anim(const char * filename, int frames);

	void animate();
	void draw(int x, int y, int alp);
	void draw_ext(float x, float y, float ang, float alp, float xs, float ys);

	private:
	//frame, dir etc.
	int num_frames;
	int index;
	int angle;
	int frame;
	int inc;

};

class Tileset : public Sprite {

	public:

	Tileset(const char * filename, int cols, int rows);

	void draw(int cell, int x, int y);
	void draw_ext(int tx, int ty, int tw, int th, int x, int y);
	int get_index(int col, int row);
	void settings(int width, int height, int xoff, int yoff, int sepx, int sepy);

	private:

	int num_cols;
	int num_rows;
	int num_cells;
	int sep_x, sep_y, offset_x, offset_y;

};

class Strip : public Sprite {

	public:

	Strip(const char * filename, int cells);

	void draw(int cell, int x, int y, bool flipx, bool flipy);

	private:

	int num_cells;

};


#endif // ANIM_H_INCLUDED
