#include "control.h"

Control::Control() {

	was_active = false;
	is_active = false;

	buf_press = false;
	buf_release = false;
	buf_down = false;

	do_press = false;
	do_release = false;
	do_down = false;

}

void Control::update(bool active) {

	// Logic
	was_active = is_active;
	is_active = active;

	// Memorize actions
	if(!was_active && is_active) buf_press=true;
	if(was_active && !is_active) buf_release=true;
	if(is_active) buf_down=true;
	else buf_down=false;

}

void Control::sync() {

	// Readable state bools
	do_press = buf_press;
	do_release = buf_release;
	do_down = buf_down;

	// Reset for next updates
	buf_press = false;
	buf_release = false;
	//buf_down = false; //This is actually only changed when control is updated with new value

}

bool Control::pressed() {

	return do_press;

}

bool Control::released() {

	return do_release;

}

bool Control::down() {

	return do_down;

}

