#ifndef CONTROL_H_INCLUDED
#define CONTROL_H_INCLUDED


class Control {

	public:

	Control();

	// Change the state of the control
	void update(bool active);
	// Keep things up to date with the loop
	void sync();

	// Retrieve the states since last sync
	// All of these may return true in the same frame
	bool pressed();
	bool released();
	bool down();

	private:

	// In low FPS situations buf will hold all states of the control since last frame
	bool buf_press;
	bool buf_release;
	bool buf_down;

	// Use this after syncronizing to get states
	bool do_press;
	bool do_release;
	bool do_down;

	// Internal logical vars
	bool was_active;
	bool is_active;

};

#endif // CONTROL_H_INCLUDED
