#include "game.h"


Game::Game(int w, int h) :
    ply(100.0, 100.0),
    lvl(200, 8) {

    edit = new eEditor(this);

    width = w;
    height = h;

    ResourceManager::resMan->add_resource("fnt/DAYROM__.ttf", FILE_TYPE_FNT, true, 14);
	fnt = ResourceManager::resMan->get_fnt("fnt/DAYROM__.ttf", 14);


    // Init draw list
    draw_list_len = 0;
    draw_list_max = 256;

    draw_list = new Obstacle*[draw_list_max];

	// Fill list with null pointers
	for( int i=0; i<draw_list_max; i++ ) {
        draw_list[i] = 0;
    }

    xoffset = 0.0;
    yoffset = (360.0-256.0)/2.0; ///TODO: Use actual vals

    spawn_count = 0;
    spawn_delay = 124;


    isEditing = false;


}

Game::~Game() {

    //Deallocate draw list
	delete [] draw_list;

    delete edit;

}


int Game::get_width() {
    return width;
}

int Game::get_height() {
    return height;
}

void Game::add_obst(double mx, double my) {

    int mcol, mrow;
        mcol = mx / lvl.get_width();
        mrow = my / lvl.get_height();

    if(lvl.get_obst(mcol, mrow)==0) {
        Obstacle *it = lvl.add_obst(mx, my);
        if(draw_list_len<draw_list_max) {
            draw_list[draw_list_len] = it;
            draw_list_len++;
        }

    }


}

void Game::rem_obst(double mx, double my) {

    int mcol, mrow;
        mcol = mx / lvl.get_width();
        mrow = my / lvl.get_height();

    Obstacle *it = lvl.get_obst(mcol, mrow);
    if(it==0) return;

    for( int i=0; i<draw_list_len; i++ ) {
        if(draw_list[i]==it) draw_list[i] = 0;
        lvl.rem_obst(it);
    }

}

Player * Game::get_ply() {

    return &ply;
}

void Game::run(long a, ActionManager& act, Keyboard& inp_keyboard, Mouse& inp_mouse) {

    //QUICKTOGGLE EDIT MODE
    if(inp_keyboard.get_any()->pressed()) {
        if(inp_keyboard.get_anycode()==ALLEGRO_KEY_F1) {
            isEditing = !isEditing;
        }
    }



    if(isEditing) {
        edit->update(inp_mouse, inp_keyboard);
    } else {


        for( int i=0; i<draw_list_len; i++ ) {
            if(draw_list[i]!=0) {
                if(draw_list[i]->hp<=0.0) rem_obst(draw_list[i]->get_c()*lvl.get_width(), draw_list[i]->get_r()*lvl.get_height());
            }

        }

        xoffset-=0.8;
        spawn_count++;
        if(spawn_count>=spawn_delay) {

            add_obst(width-xoffset, (rand()%lvl.get_rows())*lvl.get_height());
            spawn_count = 0;
            spawn_delay--;
        }


        ply.update(act, lvl);
    }



}


void Game::display(long a) {

    if(isEditing) al_clear_to_color(al_map_rgb(0,0,255));
    else          al_clear_to_color(al_map_rgb(0,255,255));

    al_draw_filled_rectangle(0,yoffset,lvl.get_total_width(), yoffset+lvl.get_total_height(), al_map_rgba(255,255,255,63));

    for( int i=0; i<draw_list_len; i++ ) {
        if(draw_list[i]!=0) {
            draw_list[i]->draw(xoffset, yoffset);
        }

    }

    ply.draw(xoffset, yoffset);

}
