#ifndef GAME_H_INCLUDED
#define GAME_H_INCLUDED

#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>

#include "resources.h"
#include "mouse.h"
#include "key.h"
#include "action.h"
#include "sound.h"

#include "eEditor.h"
#include "player.h"
#include "level.h"
#include "obstacle.h"

class eEditor;
class Game {

	public:

	Game(int w, int h);
	~Game();

	void run(long a, ActionManager& act, Keyboard& inp_keyboard, Mouse& inp_mouse);
	void display(long a);

    int get_width();
    int get_height();

    Player *get_ply();
    void add_obst(double mx, double my);
    void rem_obst(double mx, double my);


	private:

    int width;  //Screen width
    int height; //Screen height

    // Game objects
    Player ply;
    Level lvl;

    double xoffset;
    double yoffset;

    int spawn_count;
    int spawn_delay;

    Obstacle **draw_list;
    int draw_list_len;
    int draw_list_max;

    //EDIT
    bool isEditing;
    eEditor *edit;

	ALLEGRO_FONT *fnt;

};


#endif // GAME_H_INCLUDED
