#ifndef KEY_H_INCLUDED
#define KEY_H_INCLUDED

#include <allegro5/allegro.h>
#include "control.h"

const int NUM_KEYS = 13;

enum KEY_TYPE {
	KEY_TYPE_QUIT,
	KEY_TYPE_START,
	KEY_TYPE_SELECT,
	KEY_TYPE_ACT1,
	KEY_TYPE_ACT2,
	KEY_TYPE_ACT3,
	KEY_TYPE_ACT4,
	KEY_TYPE_LTRIGGER,
	KEY_TYPE_RTRIGGER,
	KEY_TYPE_UP,
	KEY_TYPE_DOWN,
	KEY_TYPE_LEFT,
	KEY_TYPE_RIGHT
};


struct Key {
	KEY_TYPE keyType;
	int keyCode;
	Control state;
};

class Keyboard {

	public:

	// Fill in keys already known
	Keyboard();

	// Keep things updated
	void on_event(ALLEGRO_EVENT * ev);
	void on_timer();
	void on_blur();

	// Change the actual keyboard key for this type
	void set_key(KEY_TYPE key, int code1, int code2);
	int get_anycode();
	int get_keycode1(KEY_TYPE key);
	int get_keycode2(KEY_TYPE key);
	// Return a pointer to a control with the active state of the key
	Control * get_key1(KEY_TYPE key);
	Control * get_key2(KEY_TYPE key);
	const char * get_keyname1(KEY_TYPE key);
	const char * get_keyname2(KEY_TYPE key);

    KEY_TYPE conflict(int code);
	Control * get_any();


	private:

	// List of valid keys to use in a certain situation
	Key keys1[NUM_KEYS];
	Key keys2[NUM_KEYS];
	Control any;
	int anycode;

};


#endif // KEY_H_INCLUDED
