#ifndef MAINMENU_H_INCLUDED
#define MAINMENU_H_INCLUDED

class DialogMenu;


#include "menu.h"
#include "application.h"
//#include "DialogMenu.h"

enum {
    MAINMENU_BUTTON_ID_STARTGAME=1,
    MAINMENU_BUTTON_ID_KEYBOARD,
    MAINMENU_BUTTON_ID_JOYSTICK,
    MAINMENU_BUTTON_ID_HELP,
    MAINMENU_BUTTON_ID_QUIT,
    MAINMENU_BUTTON_ID_FULLSCREEN
};

enum {
    MAINMENU_DIALOG_ID_NOJOYSTICK=1
};



class MainMenu : public RootMenu {

	public:

	MainMenu(IPartSystem *sys, ActionManager& act);
	~MainMenu();

	// Button functions
	void fun_startgame();
	void fun_keyboard();
	void fun_joystick(ActionManager& act);
	void fun_help();
	void fun_quit();
	void fun_fullscreen();

    void update(ActionManager& act, Keyboard& inp_keyboard);
	void draw(long anim_time);

    //static Application *app;


	private:

	// Menu Specific Vars
    bool fullscreen;
    // --

	bool in_dialog;
    int dialog_id;
    DialogMenu *dialog;

	IButton *but_startgame;
	IButton *but_keyboard;
	IButton *but_joystick;
	IButton *but_help;
	IButton *but_quit;
	IButton *but_fullscreen;


};


#endif // MAINMENU_H_INCLUDED
