#include "misc.h"

double sign(double x) {
    if(x>0) return 1.0;
    else if(x<0) return -1.0;
    else return 0.0;
}

double minimum(double a, double b) {
    return (a<b)? a : b ;
}

double maximum(double a, double b) {
    return (a>b)? a : b ;
}

double sqr(double x) {
    return x*x;
}

double lengthdir_x(double sp, double dir) {
    return sp*cos(dir*ALLEGRO_PI/180.0);
}

double lengthdir_y(double sp, double dir) {
    return -sp*sin(dir*ALLEGRO_PI/180.0);
}

double point_direction(double x1, double y1, double x2, double y2) {
    if(y1-y2==0 && x2-x1==0) return 0.0;
    return atan2( y1-y2, x2-x1 )*180.0/ALLEGRO_PI;
}

double point_distance(double x1, double y1, double x2, double y2) {
    return sqrt((x2-x1)*(x2-x1) + (y1-y2)*(y1-y2));
}

double fixedDir(double dir) {
    while(dir>=360.0 || dir<0.0) dir -= 360*sign(dir);
    return dir;
}

double deltaDir(double dir1, double dir2) {
    double dif = fixedDir(dir2)-fixedDir(dir1);
    if(dif>180.0 || dif<-180.0) dif -= 360*sign(dif);
    return dif;
}
