#include "mouse.h"

Mouse::Mouse() :
	left(),
	right() {

	x = 320;
	y = 240;

}

void Mouse::on_event(ALLEGRO_EVENT *ev, int ox, int oy, int oo) {
	if(ev->type == ALLEGRO_EVENT_MOUSE_AXES) {
		x = ox+ev->mouse.x/oo;
		y = oy+ev->mouse.y/oo;
	} else if(ev->type == ALLEGRO_EVENT_MOUSE_BUTTON_DOWN) {
		if(ev->mouse.button==1) {
			left.update(true);
		} else if(ev->mouse.button==2) {
			right.update(true);
		}
	} else if(ev->type == ALLEGRO_EVENT_MOUSE_BUTTON_UP) {
		if(ev->mouse.button==1) {
			left.update(false);
		} else if(ev->mouse.button==2) {
			right.update(false);
		}
	}
}

void Mouse::on_timer() {
	left.sync();
	right.sync();
}

void Mouse::on_blur() {
	left.update(false);
	right.update(false);
}

int Mouse::get_x() {
	return x;
}
int Mouse::get_y() {
	return y;
}

Control * Mouse::get_left() {
	return &left;
}
Control * Mouse::get_right() {
	return &right;
}
