#include "obstacle.h"


Obstacle::Obstacle(int col, int row) {

    w = 32.0;
    h = 32.0;

    c = col;
    r = row;

    x = col*w;
    y = row*h;

    marked = false;
    type = OBSTACLE_TYPE_STANDARD;
    hp = 100.0;

    int r = rand()%100;
    if(r<5) type = OBSTACLE_TYPE_SHOOT;
    else if(r<15) type = OBSTACLE_TYPE_SHRINK;
    else if(r<30) type = OBSTACLE_TYPE_JUMP;

}

Obstacle::~Obstacle() {

}

int Obstacle::get_c() {
    return c;
}

int Obstacle::get_r() {
    return r;
}

void Obstacle::draw(int ox, int oy) {

    ALLEGRO_COLOR col;
    switch(type) {
        case OBSTACLE_TYPE_SHOOT: col = al_map_rgb(255,127,127); break;
        case OBSTACLE_TYPE_SHRINK: col = al_map_rgb(127,127,255); break;
        case OBSTACLE_TYPE_JUMP: col = al_map_rgb(127,255,127); break;
        case OBSTACLE_TYPE_STANDARD: col = al_map_rgb(hp,hp,hp); break;
    }


    if(marked) al_draw_rectangle(ox + x,oy + y, ox + x + w, oy + y + h, col, 0.0);
    else al_draw_filled_rectangle(ox + x,oy + y, ox + x + w, oy + y + h, col);

}
