#include "player.h"

Player::Player(double startx, double starty) {

    x = startx;
    y = starty;

    w = 48.0;
    h = 72.0;

    //grav = 0.0;
    gAdd = 0.95;

    xsp = 0.0;
    ysp = 0.0;

    fric = 0.88;
    spInc = 0.55;

    jumpPow = 12.0; //min 4

    // Bonus stuff
    warmth = 0.9;

}

Player::~Player() {



}

void Player::jump_to(double newx, double newy) {
    x = newx;
    y = newy;
}

void Player::update(ActionManager &act, Level &lvl) {

    if(act.held(BUT_LEFT)) {
        xsp-=spInc;
    }

    if(act.held(BUT_RIGHT)) {
        xsp+=spInc;
    }

    xsp*=fric;

    double miny = -1;
    bool foundOne = false;

    for( int cc=x/lvl.get_width(); cc<=(x+w-1.0)/lvl.get_width(); cc++ ) {
        Obstacle *gobst = lvl.get_obst(cc, (y+h-1.0+4.0)/lvl.get_height());
        if(gobst!=0) {
            if(gobst->type!=OBSTACLE_TYPE_STANDARD) continue;
            gobst->hp -= warmth;
            if(foundOne) miny = minimum(miny, gobst->get_r()*lvl.get_height()-h);
            else miny= gobst->get_r()*lvl.get_height()-h;
            foundOne=true;
        }
    }


    if((act.UP() || act.A())
    && (y>=lvl.get_total_height()-h-1.0-4.0 || foundOne)) {
        ysp = -jumpPow;
    } else if(foundOne) {
        ysp = 0.0;
        y = miny;
    } else if(y>=lvl.get_total_height()-h) {
        ysp = 0.0;
        y = lvl.get_total_height()-h;
    } else ysp+=gAdd;

    //Constrainments
    if(xsp<-lvl.get_width()) xsp = -lvl.get_width();
    if(ysp<-lvl.get_height()) ysp = -lvl.get_height();
    if(xsp>lvl.get_width()) xsp = lvl.get_width();
    if(ysp>lvl.get_height()) ysp = lvl.get_height();

    double nx, ny;
        nx = x+xsp;
        ny = y+ysp;

    int c1,r1,c2,r2;
        c1 = nx/lvl.get_width();
        r1 = ny/lvl.get_height();
        c2 = (nx+w-1.0)/lvl.get_width();
        r2 = (ny+h-1.0)/lvl.get_height();

    for( int rr=y/lvl.get_height(); rr<=(y+h-1.0)/lvl.get_height(); rr++ ) {

        Obstacle *xobst;
        if(xsp>=0) xobst = lvl.get_obst(c2, rr);
        else       xobst = lvl.get_obst(c1, rr);

        if(xobst!=0) {

            if(xobst->type==OBSTACLE_TYPE_JUMP) {

                if(!xobst->marked) jumpPow += 5;
                xobst->marked = true;
                continue;
            }

            if(xobst->type==OBSTACLE_TYPE_SHRINK) {

                if(!xobst->marked) {
                    w -= 16.0;
                    h -= 16.0;
                    x += 8.0;
                    y += 8.0;
                }
                xobst->marked = true;
                continue;
            }

            if(xobst->type==OBSTACLE_TYPE_SHOOT) {

                if(!xobst->marked) {

                }
                xobst->marked = true;
                continue;
            }

            xobst->hp -= warmth;

            if(xsp>=0.0) {
                nx = xobst->get_c()*lvl.get_width()-w;
            } else {
                nx = (xobst->get_c()+1)*lvl.get_width();
            }

            xsp = 0.0;
        }

    }

    for( int cc=x/lvl.get_width(); cc<=(x+w-1.0)/lvl.get_width(); cc++ ) {

        Obstacle *yobst;
        if(ysp>=0) yobst = lvl.get_obst(cc, r2);
        else       yobst = lvl.get_obst(cc, r1);

        if(yobst!=0) {

            if(yobst->type==OBSTACLE_TYPE_JUMP) {

                if(!yobst->marked) jumpPow += 5;
                yobst->marked = true;
                continue;
            }

            if(yobst->type==OBSTACLE_TYPE_SHRINK) {

                if(!yobst->marked) {
                    w -= 16.0;
                    h -= 16.0;
                    x += 8.0;
                    y += 8.0;
                }
                yobst->marked = true;
                continue;
            }

            if(yobst->type==OBSTACLE_TYPE_SHOOT) {

                if(!yobst->marked) {

                }
                yobst->marked = true;
                continue;
            }

            yobst->hp -= warmth;

            if(ysp>=0.0) {
                ny = yobst->get_r()*lvl.get_height()-h;
            } else {
                ny = (yobst->get_r()+1)*lvl.get_height();
            }

            ysp = 0;
        }

    }

    x = nx;
    y = ny;

}

void Player::draw(int ox, int oy) {

    al_draw_rectangle(ox + x,oy + y, ox + x + w, oy + y + h, al_map_rgb(0,255,0), 2.0);
    al_draw_ellipse(ox + x + w/2.0,oy + y + h/2.0, w/2.0, h/2.0, al_map_rgb(0,255,0), 2.0);
    al_draw_circle(ox + x, oy + y, 4, al_map_rgb(0,255,0), 2.0);



}
