#ifndef PLAYER_H_INCLUDED
#define PLAYER_H_INCLUDED

#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>

#include "misc.h"

#include "action.h"
#include "level.h"

class Player {

    public:

    Player(double startx, double starty);
    ~Player();

    void jump_to(double newx, double newy);

    void update(ActionManager &act, Level &lvl);
    void draw(int ox, int oy);


    private:

    double x;
    double y;
    double w;
    double h;

    // Gravity
    //double grav;
    double gAdd;

    double jumpPow;

    // Motion
    double xsp;
    double ysp;
    double fric;
    double spInc;

    // Bonus
    double warmth;

};

#endif // PLAYER_H_INCLUDED
