#ifndef RESOURCES_H_INCLUDED
#define RESOURCES_H_INCLUDED

#include <iostream>
#include <stdio.h>
#include <map>
#include <string>
#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_color.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_acodec.h>

enum FILE_TYPE {
    FILE_TYPE_BMP,
    FILE_TYPE_SND,
    FILE_TYPE_FNT
};

struct BMP_resource {
    //std::string filepath;
    ALLEGRO_BITMAP *gfx;
    int w, h;
	bool isLoaded;
	bool isInitialized;
};

struct SND_resource {
    //std::string filepath;
    //float gain, pan, speed;
    bool is_aquired;
    ALLEGRO_SAMPLE *snd;
};

struct FNT_resource {
    //std::string filepath;
    bool is_aquired;
    ALLEGRO_FONT *fnt;
};


class ResourceManager {

    public:

    ResourceManager();
    ~ResourceManager();

    static ResourceManager * resMan;

    bool add_resource(const std::string& path, FILE_TYPE typ, bool do_aquire, int fnt_size=0);
    void remove_resource(const std::string& path, FILE_TYPE typ);

    bool aquire(const std::string& path, FILE_TYPE typ, int fnt_size=0);
    void unaquire(const std::string& path, FILE_TYPE typ);

    ALLEGRO_BITMAP * get_bmp(const std::string& path);
    ALLEGRO_SAMPLE * get_snd(const std::string& path);
    ALLEGRO_FONT * get_fnt(const std::string& path, int fnt_size=0);

    private:

    std::map<std::string , BMP_resource> map_bitmaps;
    std::map<std::string , SND_resource> map_sounds;
    std::map<std::string , FNT_resource> map_fonts;


};


#endif // RESOURCES_H_INCLUDED
