#ifndef TRANSITION_H_INCLUDED
#define TRANSITION_H_INCLUDED

#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_color.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>


enum TRANS_TYPE {
	TRANS_TYPE_RANDOM
};

class Transition {

    public:

    Transition(int w, int h);

    void setup(ALLEGRO_BITMAP *bmp, int frames, TRANS_TYPE typ);
    void transfer(ALLEGRO_BITMAP *bmp);
    bool isTransfering();

    ALLEGRO_BITMAP *get();


    private:

    int display_width, display_height;

    TRANS_TYPE type;

    int frame_count;
    int frame_delay;
    int alpha;

    void cleanup();
    bool transfering;

    ALLEGRO_BITMAP *a;
    ALLEGRO_BITMAP *b;


};

#endif // TRANSITION_H_INCLUDED
