#include <math.h>
#include "vector2d.h"


Vector2D::Vector2D() {
	x = 0.0;
	y = 0.0;
}

Vector2D::Vector2D(Vector2D * dub) {
	x = dub->x;
	y = dub->y;

}

Vector2D::Vector2D(double nx, double ny) {
	x = nx;
	y = ny;
}


void Vector2D::add(Vector2D v) {

	x += v.x;
	y += v.y;

}

void Vector2D::add(double ax, double ay) {

	x += ax;
	y += ay;

}

void Vector2D::subtract(Vector2D v) {

	x -= v.x;
	y -= v.y;

}

void Vector2D::subtract(double sx, double sy) {

	x -= sx;
	y -= sy;

}

void Vector2D::multiply(Vector2D v) {

	x *= v.x;
	y *= v.y;

}

void Vector2D::multiply(double mx, double my) {

	x *= mx;
	y *= my;

}

void Vector2D::divide(Vector2D v) {

	x /= v.x;
	y /= v.y;

}

void Vector2D::divide(double dx, double dy) {

	x /= dx;
	y /= dy;

}

void Vector2D::set(Vector2D v) {

	x = v.x;
	y = v.y;

}


void Vector2D::set(double nx, double ny) {

	x = nx;
	y = ny;

}

double Vector2D::dot(Vector2D v) {

	return v.x*x + v.y*y;

}

void Vector2D::normalize() {

	double len = sqrt(x*x + y*y);

	x /= len;
	y /= len;

}

Vector2D Vector2D::addVectors(Vector2D v1, Vector2D v2) {

	Vector2D v;

	v.x = v1.x + v2.x;
	v.y = v1.y + v2.y;

	return v;

}


Vector2D Vector2D::subtractVectors(Vector2D v1, Vector2D v2) {

	Vector2D v;

	v.x = v1.x - v2.x;
	v.y = v1.y - v2.y;

	return v;

}

Vector2D Vector2D::multiplyVectors(Vector2D v1, Vector2D v2) {

	Vector2D v;

	v.x = v1.x * v2.x;
	v.y = v1.y * v2.y;

	return v;

}


Vector2D Vector2D::divideVectors(Vector2D v1, Vector2D v2) {

	Vector2D v;

	v.x = v1.x / v2.x;
	v.y = v1.y / v2.y;

	return v;

}

double Vector2D::dotVectors(Vector2D v1, Vector2D v2) {

	return v1.x*v2.x + v1.y*v2.y;

}
