#ifndef VECTOR2D_H_INCLUDED
#define VECTOR2D_H_INCLUDED

class Vector2D {

	public:

	double x, y;

	Vector2D();
	Vector2D(Vector2D * dub);
	Vector2D(double nx, double ny);

	void add(Vector2D v);
	void add(double ax, double ay);
	void subtract(Vector2D v);
	void subtract(double sx, double sy);
	void multiply(Vector2D v);
	void multiply(double mx, double my);
	void divide(Vector2D v);
	void divide(double dx, double dy);

	void set(Vector2D v);
	void set(double nx, double ny);
	double dot(Vector2D v);
	void normalize();

	static Vector2D addVectors(Vector2D v1, Vector2D v2);
	static Vector2D subtractVectors(Vector2D v1, Vector2D v2);
	static Vector2D multiplyVectors(Vector2D v1, Vector2D v2);
	static Vector2D divideVectors(Vector2D v1, Vector2D v2);
	static double dotVectors(Vector2D v1, Vector2D v2);

};

#endif // VECTOR2D_H_INCLUDED
