#include <math.h>
#include "vector3d.h"


Vector3D::Vector3D() {
	x = 0.0;
	y = 0.0;
	z = 0.0;

}

Vector3D::Vector3D(Vector3D * dub) {
	x = dub->x;
	y = dub->y;
	z = dub->z;

}

Vector3D::Vector3D(double nx, double ny, double nz) {
	x = nx;
	y = ny;
	z = nz;

}


void Vector3D::add(Vector3D v) {

	x += v.x;
	y += v.y;
	z += v.z;

}

void Vector3D::add(double ax, double ay, double az) {

	x += ax;
	y += ay;
	z += az;

}

void Vector3D::subtract(Vector3D v) {

	x -= v.x;
	y -= v.y;
	z -= v.z;

}

void Vector3D::subtract(double sx, double sy, double sz) {

	x -= sx;
	y -= sy;
	z -= sz;

}

void Vector3D::multiply(Vector3D v) {

	x *= v.x;
	y *= v.y;
	z *= v.z;

}

void Vector3D::multiply(double mx, double my, double mz) {

	x *= mx;
	y *= my;
	z *= mz;

}

void Vector3D::divide(Vector3D v) {

	x /= v.x;
	y /= v.y;
	z /= v.z;

}

void Vector3D::divide(double dx, double dy, double dz) {

	x /= dx;
	y /= dy;
	z /= dz;

}

void Vector3D::set(Vector3D v) {

	x = v.x;
	y = v.y;
	z = v.z;

}


void Vector3D::set(double nx, double ny, double nz) {

	x = nx;
	y = ny;
	z = nz;

}

double Vector3D::dot(Vector3D v) {

	return v.x*x + v.y*y + v.z*z;

}

void Vector3D::normalize() {

	double len = sqrt(x*x + y*y + z*z);

	x /= len;
	y /= len;
	z /= len;

}

Vector3D Vector3D::addVectors(Vector3D v1, Vector3D v2) {

	Vector3D v;

	v.x = v1.x + v2.x;
	v.y = v1.y + v2.y;
	v.z = v1.z + v2.z;

	return v;

}


Vector3D Vector3D::subtractVectors(Vector3D v1, Vector3D v2) {

	Vector3D v;

	v.x = v1.x - v2.x;
	v.y = v1.y - v2.y;
	v.z = v1.z - v2.z;

	return v;

}

Vector3D Vector3D::multiplyVectors(Vector3D v1, Vector3D v2) {

	Vector3D v;

	v.x = v1.x * v2.x;
	v.y = v1.y * v2.y;
	v.z = v1.z * v2.z;

	return v;

}


Vector3D Vector3D::divideVectors(Vector3D v1, Vector3D v2) {

	Vector3D v;

	v.x = v1.x / v2.x;
	v.y = v1.y / v2.y;
	v.z = v1.z / v2.z;

	return v;

}

double Vector3D::dotVectors(Vector3D v1, Vector3D v2) {

	return v1.x*v2.x + v1.y*v2.y + v1.z*v2.z;

}

Vector3D Vector3D::crossVectors(Vector3D v1, Vector3D v2) {

	Vector3D v;

	v.x = v1.y*v2.z - v2.y*v1.z;
	v.y = v1.z*v2.x - v2.z*v1.x;
	v.z = v1.x*v2.y - v2.x*v1.y;

	return v;

}
