#ifndef VECTOR3D_H_INCLUDED
#define VECTOR3D_H_INCLUDED

class Vector3D {

	public:

	double x, y, z;

	Vector3D();
	Vector3D(Vector3D * dub);
	Vector3D(double nx, double ny, double nz);

	void add(Vector3D v);
	void add(double ax, double ay, double az);
	void subtract(Vector3D v);
	void subtract(double sx, double sy, double sz);
	void multiply(Vector3D v);
	void multiply(double mx, double my, double mz);
	void divide(Vector3D v);
	void divide(double dx, double dy, double dz);

	void set(Vector3D v);
	void set(double nx, double ny, double nz);
	double dot(Vector3D v);
	void normalize();

	static Vector3D addVectors(Vector3D v1, Vector3D v2);
	static Vector3D subtractVectors(Vector3D v1, Vector3D v2);
	static Vector3D multiplyVectors(Vector3D v1, Vector3D v2);
	static Vector3D divideVectors(Vector3D v1, Vector3D v2);
	static double dotVectors(Vector3D v1, Vector3D v2);
	static Vector3D crossVectors(Vector3D v1, Vector3D v2);

};

#endif // VECTOR3D_H_INCLUDED
